# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

cholC <- function(x) {
    .Call(`_GauPro_cholC`, x)
}

solveC <- function(A, b) {
    .Call(`_GauPro_solveC`, A, b)
}

corr_gauss_matrixC <- function(x, y, theta) {
    .Call(`_GauPro_corr_gauss_matrixC`, x, y, theta)
}

#' Correlation Gaussian matrix in C (symmetric)
#' @param x Matrix x
#' @param theta Theta vector
#' @return Correlation matrix
#' @export
#' @examples
#' corr_gauss_matrix_symC(matrix(c(1,0,0,1),2,2),c(1,1))
corr_gauss_matrix_symC <- function(x, theta) {
    .Call(`_GauPro_corr_gauss_matrix_symC`, x, theta)
}

corr_gauss_matrixvecC <- function(x, y, theta) {
    .Call(`_GauPro_corr_gauss_matrixvecC`, x, y, theta)
}

#' Correlation Gaussian matrix in C using Armadillo (symmetric)
#' @param x Matrix x
#' @param theta Theta vector
#' @return Correlation matrix
#' @examples
#' corr_gauss_matrix_sym_armaC(matrix(c(1,0,0,1),2,2),c(1,1))
#' @export
corr_gauss_matrix_sym_armaC <- function(x, theta) {
    .Call(`_GauPro_corr_gauss_matrix_sym_armaC`, x, theta)
}

deviance_part <- function(theta, nug, X, Z, Kinv) {
    .Call(`_GauPro_deviance_part`, theta, nug, X, Z, Kinv)
}

devianceC <- function(theta, nug, X, Z, K) {
    .Call(`_GauPro_devianceC`, theta, nug, X, Z, K)
}

deviance_fngr_theta <- function(X, Z, K) {
    .Call(`_GauPro_deviance_fngr_theta`, X, Z, K)
}

deviance_fngr_nug <- function(X, Z, K) {
    .Call(`_GauPro_deviance_fngr_nug`, X, Z, K)
}

deviance_fngr_joint <- function(X, Z, K) {
    .Call(`_GauPro_deviance_fngr_joint`, X, Z, K)
}

deviance_grad_theta <- function(X, K, Kinv, y) {
    .Call(`_GauPro_deviance_grad_theta`, X, K, Kinv, y)
}

deviance_grad_nug <- function(X, K, Kinv, y) {
    .Call(`_GauPro_deviance_grad_nug`, X, K, Kinv, y)
}

deviance_grad_joint <- function(X, K, Kinv, y) {
    .Call(`_GauPro_deviance_grad_joint`, X, K, Kinv, y)
}

Gaussian_deviance_part <- function(theta, nug, X, Z, Kinv) {
    .Call(`_GauPro_Gaussian_deviance_part`, theta, nug, X, Z, Kinv)
}

#' Calculate the Gaussian deviance in C
#' @param X Matrix X
#' @param Z Matrix Z
#' @param theta Theta vector
#' @param nug Nugget
#' @return Correlation matrix
#' @examples
#' Gaussian_devianceC(c(1,1), 1e-8, matrix(c(1,0,0,1),2,2), matrix(c(1,0),2,1))
#' @export
Gaussian_devianceC <- function(theta, nug, X, Z) {
    .Call(`_GauPro_Gaussian_devianceC`, theta, nug, X, Z)
}

#' Gaussian hessian in C
#'
#' @param XX point to find Hessian at
#' @param X matrix of data points
#' @param Z matrix of output
#' @param Kinv inverse of correlation matrix
#' @param mu_hat mean estimate
#' @param theta correlation parameters
#'
#' @return Hessian matrix
#' @export
Gaussian_hessianCC <- function(XX, X, Z, Kinv, mu_hat, theta) {
    .Call(`_GauPro_Gaussian_hessianCC`, XX, X, Z, Kinv, mu_hat, theta)
}

rcpp_hello_world <- function() {
    .Call(`_GauPro_rcpp_hello_world`)
}

pred_meanC <- function(XX, kx_xx, mu_hat, Kinv, Z) {
    .Call(`_GauPro_pred_meanC`, XX, kx_xx, mu_hat, Kinv, Z)
}

pred_var <- function(XX, kxx, kx_xx, s2_hat, Kinv, Z) {
    .Call(`_GauPro_pred_var`, XX, kxx, kx_xx, s2_hat, Kinv, Z)
}

pred_cov <- function(XX, kxx, kx_xx, s2_hat, Kinv, Z) {
    .Call(`_GauPro_pred_cov`, XX, kxx, kx_xx, s2_hat, Kinv, Z)
}

pred_meanC_mumat <- function(XX, kx_xx, mu_hatX, mu_hatXX, Kinv, Z) {
    .Call(`_GauPro_pred_meanC_mumat`, XX, kx_xx, mu_hatX, mu_hatXX, Kinv, Z)
}

